import java.io.File;
import java.io.Writer;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.io.FileInputStream;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import com.borland.jbcl.layout.*;
import java.util.Vector;
import java.text.DecimalFormat;


public class AdminGUI extends JFrame implements Constants{
  private JPanel pnlButtons = new JPanel();
  private JPanel pnlHeader = new JPanel();
  private JScrollPane jScrollPane1 = new JScrollPane();
  private JPanel jPanel3 = new JPanel();
  private FlowLayout flowLayout1 = new FlowLayout();
  private JButton btnClose = new JButton();
  private DBController dbController;
  private BorderLayout borderLayout1 = new BorderLayout();
  private XYLayout xYLayout1 = new XYLayout();
  private JButton btnGenerateReport1 = new JButton();
  private JLabel jLabel1 = new JLabel();
  private JLabel jLabel2 = new JLabel();
  private JComboBox cmbExperiments = null;
  private Vector v_exp = new Vector();
  private JLabel lblError = new JLabel();
  private JTextField txtfReportNamePrefix = new JTextField();
  private JLabel jLabel3 = new JLabel();
  private JLabel lblFileEnding = new JLabel();
  private int experimentID;
  private JLabel jLabel4 = new JLabel();
  private JButton btnGenerateFARFRR = new JButton();
  private JLabel jLabel5 = new JLabel();
  private JLabel jLabel6 = new JLabel();
  private JButton btnGenerateReport2 = new JButton();
  private JButton btnAverage = new JButton();
  private JLabel jLabel7 = new JLabel();
  private JLabel jLabel8 = new JLabel();
  private JButton btnGenerateErrorRates = new JButton();


  public AdminGUI(DBController dbController) {
    super("IC_Administrator 1.0 - Developed by Tom Fladsrud");
    this.dbController = dbController;
    try {
      v_exp = dbController.getExperiments();
      if(!v_exp.isEmpty()){
         cmbExperiments = new JComboBox(new Functions().getExpToCmb(v_exp));
      }else{
         cmbExperiments = new JComboBox();
      }
      cmbExperiments_actionPerformed();

         jbInit();
         this.setSize(REG_SIZE_W, REG_SIZE_H);
         Functions.centerVindu(this);
         this.setResizable(false);
         this.show();

    }
    catch(Exception e) {
      e.printStackTrace();
      JOptionPane.showMessageDialog(null, "Error at startup. Program will exit.\n"+e.getMessage());
      System.exit(2);
    }
  }
  public static void main(String[] args) {
    try{
      AdminGUI adminGUI1 = new AdminGUI(new DBController());
    }catch(Exception e){
      e.printStackTrace();
      JOptionPane.showMessageDialog(null, "Error at startup. Program will exit.\n"+e.getMessage());
      System.exit(3);
    }
  }

  private void jbInit() throws Exception {
    this.addWindowListener(new WindowAdapter(){
          public void windowClosing(WindowEvent e){
            //closeProgram();
          }
        });
    pnlHeader.setPreferredSize(new Dimension(10, 70));
    pnlHeader.setLayout(borderLayout1);
    pnlButtons.setPreferredSize(new Dimension(10, 50));
    pnlButtons.setLayout(flowLayout1);
    flowLayout1.setAlignment(FlowLayout.RIGHT);
    btnClose.setText("Close");
    btnClose.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnClose_actionPerformed(e);
      }
    });
    jPanel3.setLayout(xYLayout1);
    btnGenerateReport1.setText("Generate");
    btnGenerateReport1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnGenerateReport1_actionPerformed(e);
      }
    });
    jLabel1.setText("Generate semicolon (;) separated reports for easy use in statistic " +
    "ananyzis tools");
    jLabel2.setText("Choose experiment");
    lblError.setFont(new java.awt.Font("Dialog", 1, 12));
    lblError.setForeground(Color.red);
    this.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
    jLabel3.setText("Prefix Report");
    lblFileEnding.setToolTipText("");
    cmbExperiments.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        cmbExperiments_actionPerformed();
      }
    });
    txtfReportNamePrefix.setHorizontalAlignment(SwingConstants.RIGHT);
    jLabel4.setText("Report type 1 - All neccesary data from the database included ordered " +
    "by images");
    btnGenerateFARFRR.setText("Generate");
    btnGenerateFARFRR.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnGenerateFARFRR_actionPerformed(e);
      }
    });
    jLabel5.setText("Report type 2 - Total nr. of false acceptances and false rejections " +
    "for each participant");
    jLabel6.setText("Report type 3 - All data from the database included ordered by time " +
    "of comparison");
    btnGenerateReport2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnGenerateReport2_actionPerformed(e);
      }
    });
    btnGenerateReport2.setText("Generate");
    btnAverage.setText("Generate");
    btnAverage.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnAverage_actionPerformed(e);
      }
    });
    jLabel7.setToolTipText("");
    jLabel7.setText("Report type 4 - Average values");
    jLabel8.setText("Report type 5 - Distribution of error rates for the image-pairs");
    jLabel8.setToolTipText("");
    btnGenerateErrorRates.setText("Generate");
    btnGenerateErrorRates.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnGenerateErrorRates_actionPerformed(e);
      }
    });
    this.getContentPane().add(pnlButtons, BorderLayout.SOUTH);
    this.getContentPane().add(pnlHeader, BorderLayout.NORTH);
    this.getContentPane().add(jScrollPane1,  BorderLayout.CENTER);
    jScrollPane1.getViewport().add(jPanel3, null);
    jPanel3.add(lblError, new XYConstraints(11, 5, -1, -1));
    pnlButtons.add(btnClose, null);
    pnlHeader.add(new JLabel(new ImageIcon(REG_HEADER_IMG_PATH)), BorderLayout.CENTER);
    jPanel3.add(cmbExperiments, new XYConstraints(141, 49, 441, -1));
    jPanel3.add(jLabel2, new XYConstraints(6, 51, -1, -1));
    jPanel3.add(jLabel3,  new XYConstraints(7, 78, -1, -1));
    jPanel3.add(lblFileEnding,  new XYConstraints(525, 79, -1, -1));
    jPanel3.add(txtfReportNamePrefix,  new XYConstraints(141, 77, 386, -1));
    jPanel3.add(btnGenerateFARFRR,  new XYConstraints(496, 137, -1, 22));
    jPanel3.add(btnGenerateReport1, new XYConstraints(496, 110, -1, 23));
    jPanel3.add(jLabel4, new XYConstraints(7, 112, -1, -1));
    jPanel3.add(jLabel5, new XYConstraints(7, 138, -1, -1));
    jPanel3.add(jLabel6, new XYConstraints(7, 165, -1, -1));
    jPanel3.add(jLabel7, new XYConstraints(7, 192, -1, -1));
    jPanel3.add(jLabel8, new XYConstraints(7, 220, -1, -1));
    jPanel3.add(btnGenerateErrorRates, new XYConstraints(496, 217, -1, 24));
    jPanel3.add(btnAverage, new XYConstraints(496, 190, -1, 23));
    jPanel3.add(btnGenerateReport2, new XYConstraints(496, 163, -1, 23));
    jPanel3.add(jLabel1, new XYConstraints(7, 8, -1, -1));
    txtfReportNamePrefix.setText("Report_1");
  }

  void btnClose_actionPerformed(ActionEvent e) {
    closeProgram();
  }

  void closeProgram(){
    try{
      dbController.shutdown();
    }catch(Exception e){}
    System.exit(0);
  }

  void btnGenerateReport1_actionPerformed(ActionEvent e) {
    int experimentID = new Functions().getExpIndex(this.cmbExperiments.getSelectedIndex(), v_exp);
    Vector v_part = dbController.getParticipants(experimentID);
    String file = REPORTPATH+this.txtfReportNamePrefix.getText()+lblFileEnding.getText();
    if(!v_part.isEmpty()){
      try {
        FileOutputStream fos = new FileOutputStream(file);
        Writer out = null;
        out = new OutputStreamWriter(fos);
        {//Generate header
          String s = "Participant nr;Have hair;Age;Gender;Highest educational degree;Have worked with ID";
          String tmp[] = v_part.elementAt(0).toString().split("#");
          int Experiment_ID=Integer.parseInt(tmp[0]);
          int Participant_ID=Integer.parseInt(tmp[1]);
          Vector v_compar = dbController.getComparisons(Experiment_ID,Participant_ID);
          for(int x=0;x<v_compar.size();x++){
            s+=";ImgPair_ID_"+x+";Believed Equal(0=no/1=yes)"+x+";Is Equal(0=no/1=yes);Time_spent_P_"+x;
          }
          out.write(s+";False Acceptances;False Rejections\n");
        }

        for(int i=0;i<v_part.size();i++){
          int falselyaccepted = 0;
          int falselyrejected = 0;
          String tmp[] = v_part.elementAt(i).toString().split("#");
          int Experiment_ID=Integer.parseInt(tmp[0]);
          int Participant_ID=Integer.parseInt(tmp[1]);
          int Age=Integer.parseInt(tmp[2]);
          int Gender=Integer.parseInt(tmp[3]);
          int Highestdegree_ID=Integer.parseInt(tmp[4]);
          int Job_with_ID_check=Integer.parseInt(tmp[5]);

//          System.out.println("Highestdegree_ID:"+Highestdegree_ID);
          String str =Participant_ID+";"+Experiment_ID+";"+Age+";"+Gender+";"+Highestdegree_ID+";"+Job_with_ID_check;
          Vector v_compar = dbController.getComparisons(Experiment_ID,Participant_ID);

 //         System.out.print("\n");

          for(int x=0;x<v_compar.size();x++){
            String tmp2[] = v_compar.elementAt(x).toString().split("#");
  //          int E_ID = res.getInt("Experiment_ID");
  //          int P_ID = res.getInt("Participant_ID");
            int Imagepair_ID = Integer.parseInt(tmp2[2]);
            int Alike = Integer.parseInt(tmp2[3]);
 //           System.out.print("Alike2_"+x+":"+ Alike);
            long Time_spent = Long.parseLong(tmp2[4]);
            int Same_Individual = Integer.parseInt(tmp2[5]);
            str +=";"+Imagepair_ID+";"+Alike+";"+Same_Individual+";"+Time_spent;
            if(Alike == 0 && Same_Individual == 1){
              falselyrejected++;
            }else if(Alike == 1 && Same_Individual == 0){
              falselyaccepted++;
            }
          }

          out.write(str+";"+falselyaccepted+";"+falselyrejected+"\n");
        }
        out.flush();
        out.close();
      } catch (IOException io) {
          io.printStackTrace();
      }
/*\Program Files\Windows NT\Accessories\wordpad.exe*/
      if(new Functions().showFile("explorer", file) == null){
        new Functions().showFile("less", file);
      }
    }else{
      this.lblError.setText("No elements where found for this experiment");
    }
  }

  void cmbExperiments_actionPerformed() {
      experimentID  = new Functions().getExpIndex(this.cmbExperiments.getSelectedIndex(), v_exp);
      lblFileEnding.setText("_EID_"+experimentID+".txt");
  }

  void btnGenerateFARFRR_actionPerformed(ActionEvent e) {
    int experimentID = new Functions().getExpIndex(this.cmbExperiments.getSelectedIndex(), v_exp);
    Vector v_part = dbController.getParticipants(experimentID);
    String file = REPORTPATH+this.txtfReportNamePrefix.getText()+lblFileEnding.getText();
    DecimalFormat df = new DecimalFormat("#.###");
/*    double totalage =0;
    double totalFA =0;
    double totalFR =0;
    double totalFAR =0;
    double totalFRR =0;
    double totalTER =0;
*/
    if(!v_part.isEmpty()){
      try {
        FileOutputStream fos = new FileOutputStream(file);
        Writer out = null;
        out = new OutputStreamWriter(fos);
        {//Generate header
          String s = "Participant nr;Have hair;Age;Gender;Highest educational degree;Have worked with ID";
          String tmp[] = v_part.elementAt(0).toString().split("#");
          int Experiment_ID=Integer.parseInt(tmp[0]);
          int Participant_ID=Integer.parseInt(tmp[1]);
          out.write(s+";False Acceptances;False Rejections;False Acceptance Rate;False Rejection Rate;Total Error Rate\n");
        }

        for(int i=0;i<v_part.size();i++){
          int falselyaccepted = 0;
          int falselyrejected = 0;
          String tmp[] = v_part.elementAt(i).toString().split("#");
          int Experiment_ID=Integer.parseInt(tmp[0]);
          int Participant_ID=Integer.parseInt(tmp[1]);
          int Age=Integer.parseInt(tmp[2]);
          int Gender=Integer.parseInt(tmp[3]);
          int Highestdegree_ID=Integer.parseInt(tmp[4]);
          int Job_with_ID_check=Integer.parseInt(tmp[5]);

          String str =Participant_ID+";"+Experiment_ID+";"+Age+";"+Gender+";"+Highestdegree_ID+";"+Job_with_ID_check;
          Vector v_compar = dbController.getComparisons(Experiment_ID,Participant_ID);

          for(int x=0;x<v_compar.size();x++){
            String tmp2[] = v_compar.elementAt(x).toString().split("#");
            int Alike = Integer.parseInt(tmp2[3]);
            int Same_Individual = Integer.parseInt(tmp2[5]);
            if(Alike == 0 && Same_Individual == 1){
              falselyrejected++;
            }else if(Alike == 1 && Same_Individual == 0){
              falselyaccepted++;
            }
          }

          double far = (double)(falselyaccepted*100)/v_compar.size();
          double frr = (double)(falselyrejected*100)/v_compar.size();
          double ter = far+frr;
/*          totalage +=Age;
          totalFA +=falselyaccepted;
          totalFR +=falselyrejected;
          totalFAR +=far;
          totalFRR +=frr;
          totalTER +=ter;
*/
          out.write(str+";"+falselyaccepted+";"+falselyrejected+";"+df.format(far)+";"+df.format(frr)+";"+df.format(ter)+"\n");
        }
/*        double devideon = v_part.size();
        out.write("AVERAGE;;"+df.format((totalage/devideon))+";;;"+df.format((totalFA/devideon))+";"+df.format((totalFR/devideon))+
        ";"+df.format((totalFAR/devideon))+";"+df.format((totalFRR/devideon))+";"+df.format((totalTER/devideon))+"\n");
*/
        out.flush();
        out.close();
      } catch (IOException io) {
          io.printStackTrace();
      }
/*\Program Files\Windows NT\Accessories\wordpad.exe*/
      if(new Functions().showFile("explorer", file) == null){
        new Functions().showFile("less", file);
      }
    }else{
      this.lblError.setText("No elements where found for this experiment");
    }

  }
  void btnGenerateReport2_actionPerformed(ActionEvent e) {
    int experimentID = new Functions().getExpIndex(this.cmbExperiments.getSelectedIndex(), v_exp);
    Vector v_part = dbController.getParticipants(experimentID);
    String file = REPORTPATH+this.txtfReportNamePrefix.getText()+lblFileEnding.getText();
    if(!v_part.isEmpty()){
      try {
        FileOutputStream fos = new FileOutputStream(file);
        Writer out = null;
        out = new OutputStreamWriter(fos);
        {//Generate header
          String s = "Participant nr;Have hair;Age;Gender;Highest educational degree;Have worked with ID";
          String tmp[] = v_part.elementAt(0).toString().split("#");
          int Experiment_ID=Integer.parseInt(tmp[0]);
          int Participant_ID=Integer.parseInt(tmp[1]);
          Vector v_compar = dbController.getComparisons(Experiment_ID,Participant_ID);

          for(int x=0;x<v_compar.size();x++){
            s+=";ImgPair_ID;Believed Equal(0=no/1=yes)"+x+";Is Equal(0=no/1=yes);FR=0,FA=1,Right=2;Time_spent_P_"+x;
          }
          out.write(s+";False Acceptances;False Rejections;Total time;FA 1.kvart;FA 2.kvart;FA 3.kvart;FA 4.kvart;FR 1.kvart;FR 2.kvart;FR 3.kvart;FR 4.kvart\n");
        }

        for(int i=0;i<v_part.size();i++){
          int falselyaccepted = 0;
          int falselyrejected = 0;
          String tmp[] = v_part.elementAt(i).toString().split("#");
          int Experiment_ID=Integer.parseInt(tmp[0]);
          int Participant_ID=Integer.parseInt(tmp[1]);
          int Age=Integer.parseInt(tmp[2]);
          int Gender=Integer.parseInt(tmp[3]);
          int Highestdegree_ID=Integer.parseInt(tmp[4]);
          int Job_with_ID_check=Integer.parseInt(tmp[5]);

//          System.out.println("Highestdegree_ID:"+Highestdegree_ID);
          String str =Participant_ID+";"+Experiment_ID+";"+Age+";"+Gender+";"+Highestdegree_ID+";"+Job_with_ID_check;
          Vector v_compar = dbController.getComparisons(Experiment_ID,Participant_ID);
          v_compar = Functions.reverseIfMod2(v_compar, Participant_ID);
 //         System.out.print("\n");
          long totaltime = 0;
          int fa1=0;
          int fa2=0;
          int fa3=0;
          int fa4=0;
          int fr1=0;
          int fr2=0;
          int fr3=0;
          int fr4=0;
          for(int x=0;x<v_compar.size();x++){
            String tmp2[] = v_compar.elementAt(x).toString().split("#");
  //          int E_ID = res.getInt("Experiment_ID");
  //          int P_ID = res.getInt("Participant_ID");
            int Imagepair_ID = Integer.parseInt(tmp2[2]);
            int Alike = Integer.parseInt(tmp2[3]);
 //           System.out.print("Alike2_"+x+":"+ Alike);
            long Time_spent = Long.parseLong(tmp2[4]);
            totaltime +=Time_spent;
            int Same_Individual = Integer.parseInt(tmp2[5]);
            str +=";"+Imagepair_ID+";"+Alike+";"+Same_Individual+";";
            if(Alike == 0 && Same_Individual == 1){
              ++falselyrejected;
              str+="0";
            }else if(Alike == 1 && Same_Individual == 0){
              ++falselyaccepted;
              str+="1";
            }else{
              str+="2";
            }
            str+=";"+Time_spent;

            if(x+1==v_compar.size()/4){
              fr1=falselyrejected;
              fa1=falselyaccepted;
            }else if(x+1==(v_compar.size()/4)*2){
              fr2=falselyrejected-fr1;
              fa2=falselyaccepted-fa1;
            }else if(x+1==(v_compar.size()/4)*3){
              fr3=falselyrejected-(fr1+fr2);
              fa3=falselyaccepted-(fa1+fa2);
            }else if(x+1==(v_compar.size()/4)*4){
              fr4=falselyrejected-(fr1+fr2+fr3);
              fa4=falselyaccepted-(fa1+fa2+fa3);
            }else if(x+1>v_compar.size()){
              JOptionPane.showMessageDialog(null, "To many images. All not included.");
            }



          }

          out.write(str+";"+falselyaccepted+";"+falselyrejected+";"+totaltime+";"+fa1+";"+fa2+";"+fa3+";"+fa4+";"+fr1+";"+fr2+";"+fr3+";"+fr4+"\n");
        }

        out.flush();
        out.close();
      } catch (IOException io) {
          io.printStackTrace();
      }
/*\Program Files\Windows NT\Accessories\wordpad.exe*/
      if(new Functions().showFile("explorer", file) == null){
        new Functions().showFile("less", file);
      }
    }else{
      this.lblError.setText("No elements where found for this experiment");
    }

  }

  void btnGenerateAverages_actionPerformed(ActionEvent e) {
    int experimentID = new Functions().getExpIndex(this.cmbExperiments.getSelectedIndex(), v_exp);
    Vector v_part = dbController.getParticipants(experimentID);
    String file = REPORTPATH+this.txtfReportNamePrefix.getText()+lblFileEnding.getText();
    DecimalFormat df = new DecimalFormat("#.###");
    double totalage =0;
    double totalFA =0;
    double totalFR =0;
    double totalFAR =0;
    double totalFRR =0;
    double totalTER =0;
    if(!v_part.isEmpty()){
      try {
        FileOutputStream fos = new FileOutputStream(file);
        Writer out = null;
        out = new OutputStreamWriter(fos);
        {//Generate header
          String s = "Experiment ID;Number of participants;Average age;Average False Acceptances;Average False Rejections;Average False Acceptance Rate;"+
          "Average False Rejection Rate;Average Total Error Rate\n";
          String tmp[] = v_part.elementAt(0).toString().split("#");
          int Experiment_ID=Integer.parseInt(tmp[0]);
          int Participant_ID=Integer.parseInt(tmp[1]);
          out.write(s);
        }

        for(int i=0;i<v_part.size();i++){
          int falselyaccepted = 0;
          int falselyrejected = 0;
          String tmp[] = v_part.elementAt(i).toString().split("#");
          int Experiment_ID=Integer.parseInt(tmp[0]);
          int Participant_ID=Integer.parseInt(tmp[1]);
          int Age=Integer.parseInt(tmp[2]);
          int Gender=Integer.parseInt(tmp[3]);
          int Highestdegree_ID=Integer.parseInt(tmp[4]);
          int Job_with_ID_check=Integer.parseInt(tmp[5]);

          Vector v_compar = dbController.getComparisons(Experiment_ID,Participant_ID);

          for(int x=0;x<v_compar.size();x++){
            String tmp2[] = v_compar.elementAt(x).toString().split("#");
            int Alike = Integer.parseInt(tmp2[3]);
            int Same_Individual = Integer.parseInt(tmp2[5]);
            if(Alike == 0 && Same_Individual == 1){
              falselyrejected++;
            }else if(Alike == 1 && Same_Individual == 0){
              falselyaccepted++;
            }
          }

          double far = (double)(falselyaccepted*100)/v_compar.size();
          double frr = (double)(falselyrejected*100)/v_compar.size();
          double ter = far+frr;
          totalage +=Age;
          totalFA +=falselyaccepted;
          totalFR +=falselyrejected;
          totalFAR +=far;
          totalFRR +=frr;
          totalTER +=ter;
        }
        double devideon = v_part.size();
        out.write(experimentID+";"+devideon+";"+df.format((totalage/devideon))+";"+df.format((totalFA/devideon))+";"+df.format((totalFR/devideon))+
        ";"+df.format((totalFAR/devideon))+";"+df.format((totalFRR/devideon))+";"+df.format((totalTER/devideon))+"\n");
        out.flush();
        out.close();
      } catch (IOException io) {
          io.printStackTrace();
      }
/*\Program Files\Windows NT\Accessories\wordpad.exe*/
      if(new Functions().showFile("explorer", file) == null){
        new Functions().showFile("less", file);
      }
    }else{
      this.lblError.setText("No elements where found for this experiment");
    }

  }

  void btnAverage_actionPerformed(ActionEvent e) {
    btnGenerateAverages_actionPerformed(e);
  }

  void btnGenerateErrorRates_actionPerformed(ActionEvent e) {
    int experimentID = new Functions().getExpIndex(this.cmbExperiments.getSelectedIndex(), v_exp);
    Vector v_part = dbController.getParticipants(experimentID);
    String file = REPORTPATH+this.txtfReportNamePrefix.getText()+lblFileEnding.getText();
    if(!v_part.isEmpty()){
      try {
        FileOutputStream fos = new FileOutputStream(file);
        Writer out = null;
        out = new OutputStreamWriter(fos);
        int imagecount =0;
        {//Generate header
          String tmp[] = v_part.elementAt(0).toString().split("#");
          int Experiment_ID=Integer.parseInt(tmp[0]);
          int Participant_ID=Integer.parseInt(tmp[1]);
          Vector v_compar = dbController.getComparisons(Experiment_ID,Participant_ID);
          imagecount = v_compar.size();
          out.write("Status;");
          for(int x=0;x<v_compar.size();x++){
            String tmp2[] = v_compar.elementAt(x).toString().split("#");
            int Imagepair_ID = Integer.parseInt(tmp2[2]);
            out.write(Imagepair_ID+(x==v_compar.size()-1?"":";"));
//            out.write(Imagepair_ID+";");
          }
          out.write("\n");
        }

        int imageerrors[][] = new int[imagecount][3];
        //imageerrors[][0] = right
        //imageerrors[][1] = false acceptance
        //imageerrors[][2] = false rejection
        int occurencesalikestatus[] = new int[2];
        //0=not the same,1=the same
        for(int i=0;i<v_part.size();i++){
          int falselyaccepted = 0;
          int falselyrejected = 0;
          String tmp[] = v_part.elementAt(i).toString().split("#");
          int Experiment_ID=Integer.parseInt(tmp[0]);
          int Participant_ID=Integer.parseInt(tmp[1]);
          Vector v_compar = dbController.getComparisons(Experiment_ID,Participant_ID);

          for(int x=0;x<v_compar.size();x++){
            String tmp2[] = v_compar.elementAt(x).toString().split("#");
            int Imagepair_ID = Integer.parseInt(tmp2[2]);
            int Alike = Integer.parseInt(tmp2[3]);
            int Same_Individual = Integer.parseInt(tmp2[5]);
            if(Alike == 0 && Same_Individual == 1){
              imageerrors[x][2]++;
            }else if(Alike == 1 && Same_Individual == 0){
              imageerrors[x][1]++;
            }else{
              imageerrors[x][0]++;
            }
            if(i==0)
              occurencesalikestatus[Same_Individual]++;
          }
        }
        String strheaders[] = {"Right answers","False Acceptances", "False Rejections"};
        for(int x=0;x<3;x++){
          String strut=strheaders[x]+";";
          for(int i=0;i<imagecount;i++){
            strut+=imageerrors[i][x]+(i==imagecount-1?"":";");
          }
          out.write(strut+"\n");
        }

        JOptionPane.showMessageDialog(null, "Number of image pairs that were of the same person are "+occurencesalikestatus[1]+
        "\n"+"Number of image pairs that were not of the same person are "+occurencesalikestatus[0]);

        out.flush();
        out.close();
      } catch (IOException io) {
          io.printStackTrace();
      }
/*\Program Files\Windows NT\Accessories\wordpad.exe*/
      if(new Functions().showFile("explorer", file) == null){
        new Functions().showFile("less", file);
      }
    }else{
      this.lblError.setText("No elements where found for this experiment");
    }


  }

/**
 * NB! HUSK  GJRE OM P FAR OG FRR UTREGNINGENE
 */

  }
