import java.sql.Connection;
import java.sql.SQLException;
import java.sql.*;
import java.util.Vector;

public class DBController implements Constants {
  Connection connection;

  public DBController()throws Exception {
        Class.forName(this.DB_FORNAME);
        connection = DriverManager.getConnection(this.DB_URL+this.DB_NAME,   // filenames
                                           this.DB_USER,                    // username
                                           this.DB_PW);                     // password
  }


    public synchronized void query(String expression) throws SQLException {
        Statement st = null;
        ResultSet rs = null;
        st = connection.createStatement();
        rs = st.executeQuery(expression);
        st.close();
    }

/*  public int getExperimenttype(int ExperimentID){
    int type = -1;
    Statement st;
    ResultSet res;
    String sql = "SELECT With_hair FROM Experiment_type WHERE Experiment_ID = "+ExperimentID;
    try{
      st = connection.createStatement();
      res = st.executeQuery(sql);
      if(res.next()){
          int nummer = res.getInt("With_hair");
          type = nummer;
      }else{
        System.out.println("NO ELEMENTS FOUND:: int getExperimenttype(int ExperimentID)");
      }
      st.close();
    }catch(SQLException ex){
        ex.printStackTrace();
      return -1;
    }catch(NullPointerException e){
      return -1;
    }
    return type;
  }
*/

  public Vector getDegrees(){
    Vector vdegrees = new Vector();
    Statement stfarm1;
    ResultSet resfarm1;
    String sql = "SELECT Degree_ID, Degree_name FROM Degrees ORDER BY Degree_ID";
    try{
      stfarm1 = connection.createStatement();
      resfarm1 = stfarm1.executeQuery(sql);
      if(resfarm1.next()){
        do{
          vdegrees.addElement(resfarm1.getInt("Degree_ID")+"#"+resfarm1.getString("Degree_name"));
        }while(resfarm1.next());
      }else{
          System.out.println("NO ELEMENTS FOUND: String[] getDegrees()");
      }
      stfarm1.close();
    }catch(SQLException ex){
        ex.printStackTrace();
    }
    return vdegrees;
  }

  public void shutdown() throws SQLException {
        connection.close();   // if there are no other open connection
                        // db writes out to files and shuts down
                        // this happens anyway at garbage collection
                        // when program ends
    }

  public boolean registerUser(int experimentID, int paricipantID,int gender, int age, int workedwithID, int highestDegree)throws Exception{
    boolean success = false;
/*    System.out.println("gender: "+gender);
    System.out.println("age: "+age);
    System.out.println("workedwithID: "+workedwithID);
    System.out.println("highestDegree: "+highestDegree);
*/
    query("INSERT INTO Participant(Experiment_ID, Participant_ID, Age, Gender, Highestdegree_ID, Job_with_ID_check) VALUES ("+experimentID+", "+paricipantID+
    ","+age+","+gender+","+highestDegree+","+workedwithID+")");
    return true;
  }

  /**
   * The lowest ParticipantID to use is 1
   * @param ExperimentID
   * @return
   */
  public int getNextParticipantID(int ExperimentID){
    int nextID = 0;
    Statement st;
    ResultSet res;
    String sql = "SELECT Participant_ID FROM Participant WHERE Experiment_ID = "+ExperimentID+" ORDER BY Participant_ID";
    try{
      st = connection.createStatement();
      res = st.executeQuery(sql);
      if(res.next()){
      do{
          int nr = res.getInt("Participant_ID");
          try{
            if(nr >= nextID)
              nextID = nr;
          }catch(Exception e){
            e.printStackTrace();
          }
       }while(res.next());
      }
//      else{
//        System.out.println("NO ELEMENTS FOUND:: int getNextParticipantID(int ExperimentID)");
//      }
      st.close();
    }catch(SQLException ex){
        ex.printStackTrace();
      return 1;
    }catch(NullPointerException e){
      return 1;
    }
    return nextID+1;
  }

  public Vector getImagePairs(int exp_ID){
    Vector ImagePairs = new Vector();
    Statement st;
    ResultSet res;

    String sql = "SELECT Imagepair_ID, Image_ID1, Image_ID2, Experiment_ID, Same_Individual FROM Imagepair WHERE Experiment_ID= "+exp_ID+" ORDER BY Imagepair_ID";
//    System.out.println(sql);
    try{
      st = connection.createStatement();
      res = st.executeQuery(sql);
      if(res.next()){
      do{
          int p_ID = res.getInt("Imagepair_ID");
          int ID1 = res.getInt("Image_ID1");
          int ID2 = res.getInt("Image_ID2");
          int expID = res.getInt("Experiment_ID");
          int Same_Individual = res.getInt("Same_Individual");
          Exp_Image img1 = getImage(ID1);
          Exp_Image img2 = getImage(ID2);
          try{
            ImagePairs.addElement(new Imagepair(p_ID,img1.getImage_ID(),img2.getImage_ID(),  expID, img1.getImage_Path(), img2.getImage_Path(), img1.getImage_Exp_ID(), img2.getImage_Exp_ID(), Same_Individual));
          }catch(Exception e){
            e.printStackTrace();
          }
       }while(res.next());
      }else{
        System.out.println("NO ELEMENTS FOUND:: Vector getImagePairs()");
      }
      st.close();
    }catch(SQLException ex){
        ex.printStackTrace();
      return null;
    }catch(NullPointerException e){
      return null;
    }
    return ImagePairs;
  }

  private Exp_Image getImage(int Image_ID){
    Exp_Image img = null;

    Statement st;
    ResultSet res;
    String sql = "SELECT Image_ID, Image_path, Experiment_ID FROM Image WHERE Image_ID="+Image_ID;
    try{
      st = connection.createStatement();
      res = st.executeQuery(sql);
      if(res.next()){
          int img_ID = res.getInt("Image_ID");
          String path = res.getString("Image_path");
          int Exp_ID = res.getInt("Experiment_ID");
          try{
            img = new Exp_Image(img_ID,path,Exp_ID);
          }catch(Exception e){
            e.printStackTrace();
          }
      }else{
        System.out.println("NO ELEMENTS FOUND:: Image getImage(int Image_ID)");
      }
      st.close();
    }catch(SQLException ex){
        ex.printStackTrace();
      return null;
    }catch(NullPointerException e){
      return null;
    }
    return img;
  }

  public boolean setComparison(boolean isalike, int experiment_ID, int participant_ID, int image_pair_ID, long time_spent)throws Exception{
    boolean success = false;
    int alike =-1;
    if(isalike == BOOLEAN[FALSE]){
      alike = FALSE;
    }else{
      alike = TRUE;
    }
    query("INSERT INTO Comparison(Experiment_ID, Participant_ID, Imagepair_ID, Alike, Time_spent) VALUES ("+
    experiment_ID+", "+participant_ID+","+image_pair_ID+","+alike+","+time_spent+")");
    return true;
  }


}