import javax.swing.*;
import java.awt.*;
import com.borland.jbcl.layout.*;
import java.awt.event.*;
import java.util.Vector;
import java.util.Date;
import java.io.File;

public class GUIUserregistration extends JFrame implements Constants {
  private JScrollPane jScrollPane1 = new JScrollPane();
  private JPanel jPanel1 = new JPanel();
  private FlowLayout flowLayout1 = new FlowLayout();
  private JButton btnAbort = new JButton();
  private JButton btnRegister = new JButton();
  private JPanel pnlHeader = new JPanel();
  private JPanel jPanel2 = new JPanel();
  private XYLayout xYLayout1 = new XYLayout();
  private JScrollPane jScrollPane2 = new JScrollPane();
  private JTextArea txtaInfoExp = new JTextArea();
//  private JLabel lblName = new JLabel();
  private JLabel lblGender = new JLabel();
  private JLabel lblAge = new JLabel();
  private JLabel lblHighestDegree = new JLabel();
  private JLabel lblRegHeader = new JLabel();
  private JScrollPane jScrollPane3 = new JScrollPane();
  private JTextArea txtaWorkedWithID = new JTextArea();
  private JComboBox cmbWorkedWithID = new JComboBox(CMB_WORKED_WITH_ID);
  private JComboBox cmbGender = new JComboBox(CMB_GENDER);
  private JTextField txtfAge = new JTextField();
  private JComboBox cmbHighestDegree;
  private BorderLayout borderLayout1 = new BorderLayout();
  private DBController dbControll;
  private JLabel lblErrorReg = new JLabel();
  private Vector v_Degrees = null;
  private JLabel lblParticipantID = new JLabel();
  private int participantID =-1;

  public GUIUserregistration(DBController dbControll) {
    super((Functions.EXPERIMENT_ID==WITH_HAIR?HEADER_FRAME_REGISTRATION_WITHHAIR:HEADER_FRAME_REGISTRATION_WITHOUTHAIR));
    this.dbControll = dbControll;
    try {
      v_Degrees = dbControll.getDegrees();
      //ExperimentID is sendt into the the Function class at startup through the args send into main()
      this.participantID = this.dbControll.getNextParticipantID(Functions.EXPERIMENT_ID);
      if(!v_Degrees.isEmpty()){
        cmbHighestDegree = new JComboBox(Functions.getDegreeNames(v_Degrees));
      }else{
        JOptionPane.showMessageDialog(null,"Insert degrees into DB. System will restart");
        System.exit(8);
      }
     jbInit();

      this.setSize(REG_SIZE_W, REG_SIZE_H);
      Functions.centerVindu(this);
      this.setResizable(false);
      this.show();
    }
    catch(Exception e) {
      e.printStackTrace();
      System.exit(0);
    }

  }



  private void jbInit() throws Exception {
    txtaInfoExp.setBackground(btnAbort.getBackground());
    jPanel1.setPreferredSize(new Dimension(10, 50));
    jPanel1.setLayout(flowLayout1);
    flowLayout1.setAlignment(FlowLayout.RIGHT);
    btnAbort.setText(BTN_ABORT_TEXT);
    btnAbort.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnAbort_actionPerformed(e);
      }
    });
    btnRegister.setText(BTN_REGISTER_TEXT);
    btnRegister.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnRegister_actionPerformed(e);
      }
    });
    pnlHeader.setPreferredSize(new Dimension(10, 70));
    pnlHeader.setLayout(borderLayout1);
    jPanel2.setLayout(xYLayout1);
    txtaInfoExp.setFont(new java.awt.Font("Serif", 1, 12));
    txtaInfoExp.setEditable(false);
    txtaInfoExp.setLineWrap(true);
    txtaInfoExp.setWrapStyleWord(true);
//    lblName.setText(LBL_NAME);
    lblGender.setText(LBL_GENDER);
    lblAge.setText(LBL_AGE);
    lblHighestDegree.setText(LBL_HIGHEST_DEGREE);
    lblRegHeader.setFont(new java.awt.Font("Dialog", 0, 14));
    lblRegHeader.setText(LBL_REG_INFO_HEADER);
    txtaWorkedWithID.setEditable(false);
    txtaWorkedWithID.setText(LBL_WORKED_WITH_ID);
    txtaWorkedWithID.setLineWrap(true);
    txtaWorkedWithID.setWrapStyleWord(true);
    txtaWorkedWithID.setBackground(this.btnAbort.getBackground());
    txtaWorkedWithID.setFont(new java.awt.Font("Dialog", 0, 12));
    jScrollPane3.setBorder(null);
    jScrollPane2.setBorder(null);
    jScrollPane2.setPreferredSize(new Dimension(588, 106));
    jScrollPane1.setBorder(null);
    this.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
    this.setResizable(false);
    lblErrorReg.setForeground(Color.red);
    lblParticipantID.setText(LBL_PARTICIPANT_ID+" PID="+this.participantID+", EID="+Functions.EXPERIMENT_ID);
    this.getContentPane().add(jScrollPane1, BorderLayout.CENTER);
    this.getContentPane().add(jPanel1,  BorderLayout.SOUTH);
    jPanel1.add(btnRegister, null);
    jPanel1.add(btnAbort, null);
    this.getContentPane().add(pnlHeader,  BorderLayout.NORTH);
    jScrollPane1.getViewport().add(jPanel2, null);
    jPanel2.add(jScrollPane2,              new XYConstraints(10, 8, 587, -1));
    this.txtaInfoExp.setText(TXTA_INFO_EXP);
    jScrollPane2.getViewport().add(txtaInfoExp, null);
//    jPanel2.add(lblName, new XYConstraints(12, 134, -1, -1));
    jPanel2.add(cmbWorkedWithID,                               new XYConstraints(334, 253, 89, 23));
    jPanel2.add(jScrollPane3,  new XYConstraints(11, 229, 300, 71));
    jPanel2.add(lblErrorReg,   new XYConstraints(14, 330, -1, -1));
    jPanel2.add(lblParticipantID,   new XYConstraints(13, 317, -1, -1));
    jPanel2.add(lblRegHeader,                          new XYConstraints(10, 118, -1, -1));
    jPanel2.add(lblGender,     new XYConstraints(11, 144, -1, -1));
    jPanel2.add(lblAge, new XYConstraints(11, 169, -1, -1));
    jPanel2.add(lblHighestDegree, new XYConstraints(11, 199, -1, -1));
    jPanel2.add(cmbGender, new XYConstraints(335, 142, 89, 23));
    jPanel2.add(txtfAge, new XYConstraints(335, 171, 89, 23));
    jPanel2.add(cmbHighestDegree, new XYConstraints(335, 200, 198, 23));
    jScrollPane3.getViewport().add(txtaWorkedWithID, null);
    pnlHeader.add(new JLabel(new ImageIcon(REG_HEADER_IMG_PATH)), BorderLayout.CENTER);

  }

  void btnAbort_actionPerformed(ActionEvent e) {
    System.exit(0);
  }

  void btnRegister_actionPerformed(ActionEvent e) {
    //Register information
    int age=-1;
    try{
      age = Integer.parseInt(this.txtfAge.getText().trim());
    }catch(Exception ef){
        lblErrorReg.setText(AGE_ERROR);
        this.txtfAge.requestFocus();
        return;
    }
//    int participantID = this.dbControll.getNextParticipantID(Functions.EXPERIMENT_ID);
    try{
        boolean registered = dbControll.registerUser(Functions.EXPERIMENT_ID,participantID,this.cmbGender.getSelectedIndex(), age, this.cmbWorkedWithID.getSelectedIndex(), Functions.getDegreeID(v_Degrees, this.cmbHighestDegree.getSelectedIndex()));
        if(!registered){
          lblErrorReg.setText(REGISTER_USER_ERROR);
          return;
        }
    }catch(Exception er){
        lblErrorReg.setText(REGISTER_USER_EXCEPTION+er.getMessage());
        return;
    }

    //Get experimenttype(with or without hair)
//    int withhair = dbControll.getExperimenttype(Functions.EXPERIMENT_ID);

    //Get imagepairs
    Vector v_imagepairs = dbControll.getImagePairs(Functions.EXPERIMENT_ID);

    //every other participant shall be provided the image selection in reverse order to see if the time of evaluation has an impact on performance
    Imagepair img_pair[] = Functions.getImagepairs(v_imagepairs, participantID);

    //There shall be a new box for each imagepair
    this.setVisible(false);
    for(int i=0; i<img_pair.length;i++){
        //Note the time of the start of comparison
        Date start = new Date();
        long starttime = start.getTime();
        //Get the image paths
        String image_path1 = img_pair[i].getImage_1_Path();
        String image_path2 = img_pair[i].getImage_2_Path();

//        System.out.println(img_pair[i].getImage_1_Path());
//        System.out.println(img_pair[i].getImage_2_Path());

        //Open the comparison
        GUI_Comparison comp = new GUI_Comparison(this, this.dbControll, image_path1, image_path2, (i+1),img_pair.length);
        comp.addWindowListener(new WindowAdapter(){
            public void windowClosing(WindowEvent e){
              //Do nothing. Prevent the user from closing the window with the cross in the right upper corner
            }
          });
        boolean isalike = comp.isAlike();
        comp = null;
        //Note the time of the end of comparison
        Date end = new Date();
        long endtime = end.getTime();
        long time_spent = (endtime - starttime); //Time in milliseconds

        //Store the result in the database
        try{
          dbControll.setComparison(isalike, Functions.EXPERIMENT_ID, participantID, img_pair[i].getImage_pair_ID(), time_spent);
        }catch(Exception edb){
          int answer = JOptionPane.showConfirmDialog(null, "SYSTEM ERROR :: "+edb.getMessage()+"\nContinue anyway?");
          if(answer == FALSE){
            System.exit(6);
          }
        }

    }

    //The user has finished the evaluation
    GUI_Finished finish = new GUI_Finished(this.dbControll);
    finish.addWindowListener(new WindowAdapter(){
        public void windowClosing(WindowEvent e){
          //Do nothing. Prevent the user from closing the window with the cross in the right upper corner
        }
      });

  }


}
